package sun.reflect.generics.repository;

import sun.reflect.generics.visitor.Reifier;
import sun.reflect.generics.tree.FormalTypeParameter;
import sun.reflect.generics.factory.GenericsFactory;
import java.lang.reflect.TypeVariable;
import sun.reflect.generics.tree.Signature;

public abstract class GenericDeclRepository<S extends Signature> extends AbstractRepository<S>
{
    private volatile TypeVariable<?>[] typeParams;
    
    protected GenericDeclRepository(String s, GenericsFactory genericsFactory) {
        super(s, genericsFactory);
    }
    
    public TypeVariable<?>[] getTypeParameters() {
        TypeVariable[] typeParams = this.typeParams;
        if (typeParams == null) {
            FormalTypeParameter[] formalTypeParameters = ((Signature)this.getTree()).getFormalTypeParameters();
            typeParams = new TypeVariable[formalTypeParameters.length];
            Reifier reifier;
            for (int i = 0; i < formalTypeParameters.length; typeParams[i] = (TypeVariable)reifier.getResult(), ++i) {
                reifier = this.getReifier();
                formalTypeParameters[i].accept(reifier);
            }
            this.typeParams = typeParams;
        }
        return (TypeVariable<?>[])typeParams.clone();
    }
}
